'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = Menu;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MenuWrapper = _styledComponents2.default.div.withConfig({
  displayName: 'Menu__MenuWrapper'
})(['color:', ';text-align:left;'], function (props) {
  return props.theme.colors.purple400;
});

/**
 * A menu component that can be used for navigation.
 *
 * ```javascript
 * export default function MenuExample({clickHandler}) {
 *   return (
 *     <Menu>
 *       <MenuItem onClick={clickHandler.bind(this, 'onClick')} text="Item 1" />
 *       <MenuItem onClick={clickHandler.bind(this, 'onClick')} text="Item 2" />
 *       <MenuItem
 *         onClick={clickHandler.bind(this, 'onClick')}
 *         isSubItem text="Sub Item 1"
 *       />
 *       <MenuItem
 *         onClick={clickHandler.bind(this, 'onClick')}
 *         isSubItem text="Sub Item 2"
 *       />
 *     </Menu>
 *   );
 * }
 * ```
 */
function Menu(_ref) {
  var children = _ref.children;

  return _react2.default.createElement(
    MenuWrapper,
    { className: 'weave-menu' },
    children
  );
}