'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Item = _styledComponents2.default.div.withConfig({
  displayName: 'MenuItem__Item'
})(['display:block;min-height:40px;line-height:40px;padding-left:20px;&:hover{transition:color,0.3s,ease;color:', ';background-color:', ';cursor:pointer;}', ';', ';'], function (props) {
  return !props.active && props.theme.colors.purple800;
}, function (props) {
  return !props.active && props.theme.colors.gallery;
}, function (props) {
  return props.isSubItem && '\n    font-size: 14px;\n    padding-left: 40px;\n    line-height: 30px;\n    min-height: 30px;\n  ';
}, function (props) {
  return props.active && '\n    color: ' + props.theme.colors.gallery + ';\n    background-color: ' + props.theme.colors.purple400 + ';\n  ';
});

/**
 * A child of the `<Menu />` component.
 *
 * See also [Menu](/components/menu)
 */

var MenuItem = function (_React$Component) {
  _inherits(MenuItem, _React$Component);

  function MenuItem() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, MenuItem);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = MenuItem.__proto__ || Object.getPrototypeOf(MenuItem)).call.apply(_ref, [this].concat(args))), _this), _this.handleClick = function () {
      if (_this.props.onClick) {
        _this.props.onClick(_this.props.text);
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(MenuItem, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          text = _props.text,
          children = _props.children,
          className = _props.className,
          active = _props.active,
          isSubItem = _props.isSubItem;
      // Use the className the users gives, or fall back to 'weave-menu-item'.

      var cl = (0, _classnames2.default)(className || 'weave-menu-item', {
        'menu-item-active': active
      });
      return _react2.default.createElement(
        Item,
        {
          onClick: this.handleClick,
          className: cl,
          active: active,
          isSubItem: isSubItem
        },
        _react2.default.createElement(
          'div',
          { className: 'menu-text' },
          text
        ),
        children
      );
    }
  }]);

  return MenuItem;
}(_react2.default.Component);

MenuItem.propTypes = {
  /**
   * Handler that will be run on click. The `text` prop is passed to the handler function.
   */
  onClick: _propTypes2.default.func,
  /**
   * Text that will be displayed as the menu item.
   */
  text: _propTypes2.default.string,
  /**
   * Renders small text if true.
   */
  isSubItem: _propTypes2.default.bool
};

MenuItem.defaultProps = {
  isSubItem: false
};

exports.default = MenuItem;