'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _noop2 = require('lodash/noop');

var _noop3 = _interopRequireDefault(_noop2);

var _indexOf2 = require('lodash/indexOf');

var _indexOf3 = _interopRequireDefault(_indexOf2);

var _reverse2 = require('lodash/reverse');

var _reverse3 = _interopRequireDefault(_reverse2);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _every2 = require('lodash/every');

var _every3 = _interopRequireDefault(_every2);

var _filter2 = require('lodash/filter');

var _filter3 = _interopRequireDefault(_filter2);

var _isEmpty2 = require('lodash/isEmpty');

var _isEmpty3 = _interopRequireDefault(_isEmpty2);

var _size2 = require('lodash/size');

var _size3 = _interopRequireDefault(_size2);

var _omit2 = require('lodash/omit');

var _omit3 = _interopRequireDefault(_omit2);

var _forEach2 = require('lodash/forEach');

var _forEach3 = _interopRequireDefault(_forEach2);

var _zipObject2 = require('lodash/zipObject');

var _zipObject3 = _interopRequireDefault(_zipObject2);

var _fromPairs2 = require('lodash/fromPairs');

var _fromPairs3 = _interopRequireDefault(_fromPairs2);

var _last2 = require('lodash/last');

var _last3 = _interopRequireDefault(_last2);

var _first2 = require('lodash/first');

var _first3 = _interopRequireDefault(_first2);

var _sortBy2 = require('lodash/sortBy');

var _sortBy3 = _interopRequireDefault(_sortBy2);

var _values2 = require('lodash/values');

var _values3 = _interopRequireDefault(_values2);

var _keys2 = require('lodash/keys');

var _keys3 = _interopRequireDefault(_keys2);

var _range2 = require('lodash/range');

var _range3 = _interopRequireDefault(_range2);

var _flatten2 = require('lodash/flatten');

var _flatten3 = _interopRequireDefault(_flatten2);

var _max2 = require('lodash/max');

var _max3 = _interopRequireDefault(_max2);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _d3Scale = require('d3-scale');

var _d3Format = require('d3-format');

var _d3Shape = require('d3-shape');

var _theme = require('../../theme');

var _theme2 = _interopRequireDefault(_theme);

var _Chart = require('./_Chart');

var _Chart2 = _interopRequireDefault(_Chart);

var _AxesGrid = require('./_AxesGrid');

var _AxesGrid2 = _interopRequireDefault(_AxesGrid);

var _ErrorOverlay = require('./_ErrorOverlay');

var _ErrorOverlay2 = _interopRequireDefault(_ErrorOverlay);

var _LoadingOverlay = require('./_LoadingOverlay');

var _LoadingOverlay2 = _interopRequireDefault(_LoadingOverlay);

var _DeploymentAnnotations = require('./_DeploymentAnnotations');

var _DeploymentAnnotations2 = _interopRequireDefault(_DeploymentAnnotations);

var _HoverInfo = require('./_HoverInfo');

var _HoverInfo2 = _interopRequireDefault(_HoverInfo);

var _Legend = require('./_Legend');

var _Legend2 = _interopRequireDefault(_Legend);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function parseGraphValue(value) {
  var val = parseFloat(value);
  if (Number.isNaN(val)) {
    // "+Inf", "-Inf", "+Inf" will be parsed into NaN by parseFloat(). The
    // can't be graphed, so show them as gaps (null).
    return null;
  }
  return val;
}

function asJSONString(hash) {
  // Return empty string instead of empty hash.
  if ((0, _isEmpty3.default)(hash)) return '';

  return JSON.stringify(hash, null, 1);
}

function getDefaultSeriesName(series, multiSeries) {
  var forLegend = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

  // Extract metric name in a separate variable.
  var metricName = (0, _get3.default)(series.metric, '__name__') || '';
  var metricHash = (0, _omit3.default)(series.metric, ['__name__']);

  // Handle some special cases if metric name is not present.
  if (!metricName) {
    // Return the query string if the series has no metrics.
    if ((0, _isEmpty3.default)(metricHash)) {
      return series.query;
    }
    // Return the value if only a single one is present.
    if ((0, _size3.default)(metricHash) === 1) {
      return (0, _first3.default)((0, _values3.default)(metricHash));
    }
  }

  // If multi-series context is given and more than one series is present in
  // the graph, filter out all the metric keys that appear in every series.
  if (forLegend && (0, _size3.default)(multiSeries) > 1) {
    var repeatedKeys = (0, _filter3.default)((0, _keys3.default)(metricHash), function (metricKey) {
      return (0, _every3.default)(multiSeries, function (s) {
        return s.metric[metricKey] === metricHash[metricKey];
      });
    });
    metricHash = (0, _omit3.default)(metricHash, repeatedKeys);
  }

  // Then return a stringified JSON of metrics
  // (with metric name in front if it exists).
  return '' + metricName + asJSONString(metricHash);
}

function getColorTheme(_ref) {
  var colorTheme = _ref.colorTheme,
      showStacked = _ref.showStacked;

  return function (index) {
    var colors = [].concat(_toConsumableArray(_theme2.default.colors.graphThemes[colorTheme]));

    // Reverse the order of colors for line graphs for improved visibility.
    if (!showStacked) (0, _reverse3.default)(colors);

    return colors[index % colors.length];
  };
}

var GraphWrapper = _styledComponents2.default.div.withConfig({
  displayName: 'PrometheusGraph__GraphWrapper'
})(['position:relative;padding-left:45px;']);

var GraphContainer = _styledComponents2.default.div.withConfig({
  displayName: 'PrometheusGraph__GraphContainer'
})(['position:relative;min-height:170px;margin-bottom:20px;opacity:', ';'], function (props) {
  return props.loading ? 0.35 : 1;
});

var AxisLabel = _styledComponents2.default.span.withConfig({
  displayName: 'PrometheusGraph__AxisLabel'
})(['color:', ';font-size:', ';opacity:', ';transform:translate(-60px,165px) rotate(-90deg);transform-origin:left top 0;display:inline-block;'], function (props) {
  return props.theme.colors.black;
}, function (props) {
  return props.theme.fontSizes.normal;
}, function (props) {
  return props.loading ? 0.35 : 1;
});

var valueFormatters = {
  numeric: function numeric(number) {
    var step = number / 7;
    var formatNumber = number > 10 ? (0, _d3Format.formatPrefix)('.' + (0, _d3Format.precisionPrefix)(step, number), number) : (0, _d3Format.format)('.' + (0, _d3Format.precisionFixed)(step) + 'f');
    return function (n) {
      if (n === null) return '---';
      if (n === 0) return '0';
      return formatNumber(n);
    };
  },
  seconds: function seconds(maxSeconds) {
    var data = [{ label: 'w', unit: 7 * 24 * 60 * 60 }, { label: 'd', unit: 24 * 60 * 60 }, { label: 'h', unit: 60 * 60 }, { label: 'm', unit: 60 }, { label: 's', unit: 1 }, { label: 'ms', unit: 1 / 1000 }, { label: 'µs', unit: 1 / 1000 / 1000 }].find(function (_ref2) {
      var unit = _ref2.unit;
      return maxSeconds / unit >= 2;
    });
    return function (n) {
      if (n === null) return '---';
      if (!data) return '0';
      return Math.round(n / data.unit) + ' ' + data.label;
    };
  },
  bytes: function bytes(maxBytes) {
    var data = [{ label: 'TB', unit: 1024 * 1024 * 1024 * 1024 }, { label: 'GB', unit: 1024 * 1024 * 1024 }, { label: 'MB', unit: 1024 * 1024 }, { label: 'kB', unit: 1024 }, { label: 'B', unit: 1 }].find(function (_ref3) {
      var unit = _ref3.unit;
      return maxBytes / unit >= 2;
    });
    return function (n) {
      if (n === null) return '---';
      if (!data) return '0';
      return Math.round(n / data.unit) + ' ' + data.label;
    };
  },
  percent: function percent() {
    var formatPercent = (0, _d3Format.format)('.2%');
    return function (n) {
      if (n === null) return '---';
      if (n === 0) return '0%';
      return formatPercent(n);
    };
  }
};

/**
 * Renders a graph based on Prometheus data fed through `multiSeries` prop.
 * Optionally adds deployment annotations to the graph.
 *
 * ```javascript
 * export default class PrometheusGraphExample extends React.Component {
 *   constructor() {
 *     super();
 *
 *     this.state = {
 *       multiSeries: ...,
 *       startTime: moment('2018-02-05T11:24:14Z').unix(),
 *       endTime: moment('2018-02-05T11:54:14Z').unix(),
 *       stepDuration: 9,
 *     };
 *   }
 *
 *   render() {
 *     return (
 *       <PrometheusGraph
 *         showStacked
 *         multiSeries={this.state.multiSeriesJobs}
 *         stepDurationSec={this.state.stepDuration}
 *         startTimeSec={this.state.startTime}
 *         endTimeSec={this.state.endTime}
 *         getSeriesName={({ metric }) => JSON.stringify(metric)}
 *       />
 *     );
 *   }
 * }
 * ```
 *
 */

var PrometheusGraph = function (_React$PureComponent) {
  _inherits(PrometheusGraph, _React$PureComponent);

  function PrometheusGraph(props, context) {
    _classCallCheck(this, PrometheusGraph);

    var _this = _possibleConstructorReturn(this, (PrometheusGraph.__proto__ || Object.getPrototypeOf(PrometheusGraph)).call(this, props, context));

    _initialiseProps.call(_this);

    _this.state = {
      multiSeries: [],
      selectedLegendKeys: props.selectedLegendKeys,
      selectedLegendOverride: false,
      hoveredLegendKey: null,
      hoverTimestampSec: null,
      hoverPoints: null,
      hoverX: null,
      hoverY: null,
      chartWidth: 0,
      chartHeight: 0
    };
    return _this;
  }

  _createClass(PrometheusGraph, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.prepareMultiSeries(this.props);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (this.props.multiSeries !== nextProps.multiSeries) {
        this.prepareMultiSeries(nextProps);
      }
      if (this.props.selectedLegendKeys !== nextProps.selectedLegendKeys && !this.state.selectedLegendOverride) {
        var selectedLegendKeys = nextProps.selectedLegendKeys;

        this.prepareMultiSeries(nextProps, { selectedLegendKeys: selectedLegendKeys });
        this.setState({ selectedLegendKeys: selectedLegendKeys });
      }
    }
  }, {
    key: 'getMaxGraphValue',
    value: function getMaxGraphValue() {
      var yPositions = (0, _flatten3.default)(this.getVisibleMultiSeries().map(function (series) {
        return series.datapoints.map(function (datapoint) {
          return datapoint.offset + datapoint.value;
        });
      }));
      return (0, _max3.default)([this.props.valuesMinSpread * 1.05].concat(_toConsumableArray(yPositions)));
    }
  }, {
    key: 'getTimestampQuantizer',
    value: function getTimestampQuantizer() {
      var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.props;
      var startTimeSec = props.startTimeSec,
          endTimeSec = props.endTimeSec,
          stepDurationSec = props.stepDurationSec;
      // Timestamp values are stepDurationSec seconds apart and they always end at
      // endTimeSec. We make startTimeSec a bit smaller to include it in the range in case
      // (endTimeSec - startTimeSec) is divisible by stepDurationSec.

      var timestampSecs = (0, _range3.default)(endTimeSec, startTimeSec - 1e-6, -stepDurationSec).sort();
      // scaleQuantize would normally map domain in buckets of uniform lengths. To
      // make it map to the nearest point in timestampSecs instead, we need to extend
      // the domain by half of stepDurationSec at each end.
      var startDomain = (0, _first3.default)(timestampSecs) - 0.5 * stepDurationSec;
      var endDomain = (0, _last3.default)(timestampSecs) + 0.5 * stepDurationSec;
      return (0, _d3Scale.scaleQuantize)().domain([startDomain, endDomain]).range(timestampSecs);
    }
  }, {
    key: 'getTimeScale',
    value: function getTimeScale() {
      var chartWidth = this.state.chartWidth;
      var _props = this.props,
          startTimeSec = _props.startTimeSec,
          endTimeSec = _props.endTimeSec;

      return (0, _d3Scale.scaleLinear)().domain([startTimeSec, endTimeSec]).range([0, chartWidth]);
    }
  }, {
    key: 'getValueScale',
    value: function getValueScale() {
      var chartHeight = this.state.chartHeight;

      var maxGraphValue = this.getMaxGraphValue();
      return (0, _d3Scale.scaleLinear)().domain([0, maxGraphValue]).range([chartHeight, 0]);
    }
  }, {
    key: 'getVisibleMultiSeries',
    value: function getVisibleMultiSeries() {
      var _this2 = this;

      // If no series is selected, show all of them.
      if (this.state.selectedLegendKeys.length === 0) {
        return this.state.multiSeries;
      }
      // Otherwise show only the selected multi series.
      return this.state.multiSeries.filter(function (series) {
        return _this2.state.selectedLegendKeys.includes(series.key);
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          yAxisLabel = _props2.yAxisLabel,
          deployments = _props2.deployments,
          metricUnits = _props2.metricUnits,
          showStacked = _props2.showStacked,
          simpleTooltip = _props2.simpleTooltip,
          legendShown = _props2.legendShown,
          legendCollapsable = _props2.legendCollapsable,
          loading = _props2.loading,
          error = _props2.error;
      var _state = this.state,
          selectedLegendKeys = _state.selectedLegendKeys,
          hoveredLegendKey = _state.hoveredLegendKey,
          chartWidth = _state.chartWidth,
          chartHeight = _state.chartHeight,
          hoverPoints = _state.hoverPoints,
          hoverTimestampSec = _state.hoverTimestampSec,
          hoverX = _state.hoverX,
          hoverY = _state.hoverY,
          multiSeries = _state.multiSeries;


      var timeScale = this.getTimeScale();
      var valueScale = this.getValueScale();
      var visibleMultiSeries = this.getVisibleMultiSeries();
      var timestampQuantizer = this.getTimestampQuantizer();
      var valueFormatter = valueFormatters[metricUnits];
      var hasData = multiSeries && multiSeries.length > 0;

      return _react2.default.createElement(
        GraphWrapper,
        null,
        _react2.default.createElement(
          AxisLabel,
          { loading: loading },
          yAxisLabel
        ),
        _react2.default.createElement(
          GraphContainer,
          { loading: loading },
          _react2.default.createElement(_AxesGrid2.default, {
            hasData: hasData,
            chartWidth: chartWidth,
            chartHeight: chartHeight,
            timeScale: timeScale,
            valueScale: valueScale,
            valueFormatter: valueFormatter,
            metricUnits: metricUnits
          }),
          _react2.default.createElement(_Chart2.default, {
            showStacked: showStacked,
            timeScale: timeScale,
            valueScale: valueScale,
            multiSeries: visibleMultiSeries,
            timestampQuantizer: timestampQuantizer,
            selectedLegendKeys: selectedLegendKeys,
            hoveredLegendKey: hoveredLegendKey,
            onHoverUpdate: this.handleHoverUpdate,
            onChartResize: this.handleChartResize
          }),
          hasData && _react2.default.createElement(_DeploymentAnnotations2.default, {
            deployments: deployments,
            timeScale: timeScale,
            chartWidth: chartWidth,
            chartHeight: chartHeight
          }),
          _react2.default.createElement(_HoverInfo2.default, {
            mouseX: hoverX,
            mouseY: hoverY,
            datapoints: hoverPoints,
            timestampSec: hoverTimestampSec,
            simpleTooltip: simpleTooltip,
            valueFormatter: valueFormatter,
            valueScale: valueScale,
            chartWidth: chartWidth,
            chartHeight: chartHeight
          })
        ),
        _react2.default.createElement(_Legend2.default, {
          loading: loading,
          shown: legendShown,
          collapsable: legendCollapsable,
          selectedKeys: selectedLegendKeys,
          onSelectedKeysChange: this.handleSelectedLegendKeysChange,
          onHoveredKeyChange: this.handleHoveredLegendKeyChange,
          multiSeries: multiSeries
        }),
        _react2.default.createElement(_ErrorOverlay2.default, { hasData: hasData, loading: loading, error: error }),
        _react2.default.createElement(_LoadingOverlay2.default, { loading: loading })
      );
    }
  }]);

  return PrometheusGraph;
}(_react2.default.PureComponent);

var _initialiseProps = function _initialiseProps() {
  var _this3 = this;

  this.handleSelectedLegendKeysChange = function (selectedLegendKeys) {
    _this3.prepareMultiSeries(_this3.props, { selectedLegendKeys: selectedLegendKeys });
    _this3.setState({ selectedLegendKeys: selectedLegendKeys, selectedLegendOverride: true });
    _this3.props.onChangeLegendSelection(selectedLegendKeys);
  };

  this.handleHoveredLegendKeyChange = function (hoveredLegendKey) {
    _this3.setState({ hoveredLegendKey: hoveredLegendKey });
  };

  this.handleHoverUpdate = function (_ref4) {
    var hoverPoints = _ref4.hoverPoints,
        hoverTimestampSec = _ref4.hoverTimestampSec,
        hoverX = _ref4.hoverX,
        hoverY = _ref4.hoverY;

    _this3.setState({ hoverPoints: hoverPoints, hoverTimestampSec: hoverTimestampSec, hoverX: hoverX, hoverY: hoverY });
  };

  this.handleChartResize = function (_ref5) {
    var chartWidth = _ref5.chartWidth,
        chartHeight = _ref5.chartHeight;

    _this3.setState({ chartWidth: chartWidth, chartHeight: chartHeight });
  };

  this.prepareMultiSeries = function (props) {
    var _ref6 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _this3.state,
        selectedLegendKeys = _ref6.selectedLegendKeys;

    var getSeriesColor = getColorTheme(props);
    var getSeriesName = function getSeriesName(series, forLegend) {
      return props.getSeriesName(series, props.multiSeries, forLegend);
    };

    // The key generating function will make series key equal the series name,
    // unless this is not the first series with this name, in which case the
    // index of the series within the legend is attached to the key.
    var multiSeriesByName = props.multiSeries.map(getSeriesName);
    var getSeriesKey = function getSeriesKey(series, index) {
      var seriesName = getSeriesName(series);
      var firstIndex = (0, _indexOf3.default)(multiSeriesByName, seriesName);

      var seriesKey = seriesName;
      if (firstIndex !== index) {
        seriesKey = seriesKey + '____' + index;
      }
      return seriesKey;
    };

    // Build a dictionary that references original multi series by keys,
    // and a sorted list of those keys by which we can later iterate.
    var getSeriesKeyValuePair = function getSeriesKeyValuePair(series, index) {
      return [getSeriesKey(series, index), series];
    };
    var multiSeriesByKey = (0, _fromPairs3.default)(props.multiSeries.map(getSeriesKeyValuePair));
    var multiSeriesKeys = (0, _keys3.default)(multiSeriesByKey).sort();

    // Calculate the keys of stacked series:
    //   1. If the graph isn't stacked, then this array should be empty.
    //   2. If the graph is stacked and some series are selected, only
    //      those selected ones will be displayed so only stack them.
    //   3. If the graph is stacked and no series is selected, all the
    //      series are displayed, so they should all be stacked.
    var stackedMultiSeriesKeys = [];
    if (props.showStacked) {
      stackedMultiSeriesKeys = selectedLegendKeys.length > 0 ? selectedLegendKeys : multiSeriesKeys;
    }

    // This D3 scale takes care of rounding all the datapoints to the nearest discrete timestamp.
    var timestampQuantizer = _this3.getTimestampQuantizer(props);
    var timestampSecs = timestampQuantizer.range();

    // Initialize all the graph values to null, as if the graph was empty.
    var valuesByTimestamp = {};
    timestampSecs.forEach(function (timestampSec) {
      valuesByTimestamp[timestampSec] = { timestampSec: timestampSec };
      multiSeriesKeys.forEach(function (seriesKey) {
        valuesByTimestamp[timestampSec][seriesKey] = null;
      });
    });

    // Go through the datapoints of all the series and fill in
    // their values (in a format that works for D3 stack helpers).
    (0, _forEach3.default)(multiSeriesByKey, function (series, seriesKey) {
      (0, _forEach3.default)(series.values, function (point) {
        var value = parseGraphValue(point[1]);
        var timestampSec = timestampQuantizer(point[0]);
        valuesByTimestamp[timestampSec][seriesKey] = value;
      });
    });

    // Stack the graph series in the alphabetical order.
    var stackFunction = (0, _d3Shape.stack)().keys(stackedMultiSeriesKeys);
    var valuesForStacking = (0, _sortBy3.default)((0, _values3.default)(valuesByTimestamp), ['timestampSec']);
    var stackedData = (0, _zipObject3.default)(stackedMultiSeriesKeys, stackFunction(valuesForStacking));
    var getStackedOffset = function getStackedOffset(seriesKey, timestampIndex) {
      return stackedMultiSeriesKeys.includes(seriesKey) ? stackedData[seriesKey][timestampIndex][0] : 0;
    };

    // Finally store the multi-series ready to be graphed.
    var multiSeries = multiSeriesKeys.map(function (seriesKey, seriesIndex) {
      return {
        key: seriesKey,
        color: getSeriesColor(seriesIndex),
        hoverName: getSeriesName(multiSeriesByKey[seriesKey]),
        legendName: getSeriesName(multiSeriesByKey[seriesKey], true),
        datapoints: timestampSecs.map(function (timestampSec, timestampIndex) {
          return {
            timestampSec: timestampSec,
            value: valuesByTimestamp[timestampSec][seriesKey],
            offset: getStackedOffset(seriesKey, timestampIndex)
          };
        })
      };
    });

    _this3.setState({ multiSeries: multiSeries });
  };
};

PrometheusGraph.propTypes = {
  /**
   * List of datapoints to be rendered in the graph
   */
  multiSeries: _propTypes2.default.array.isRequired,
  /**
   * Granularity in seconds between adjacent datapoints across the time scale
   */
  stepDurationSec: _propTypes2.default.number.isRequired,
  /**
   * Start timestamp of the rendered chart (unix timestamp)
   */
  startTimeSec: _propTypes2.default.number.isRequired,
  /**
   * End timestamp of the rendered chart (unix timestamp)
   */
  endTimeSec: _propTypes2.default.number.isRequired,
  /**
   * Method that builds series name from its metadata. First argument should be the series
   * itself, second argument multiSeries context and third argument options hash with only
   *
   */
  getSeriesName: _propTypes2.default.func,
  /**
   * Color theme for the graph
   */
  colorTheme: _propTypes2.default.oneOf(['mixed', 'blue', 'purple']),
  /**
   * Series values format
   */
  metricUnits: _propTypes2.default.oneOf(['numeric', 'seconds', 'bytes', 'percent']),
  /**
   * Minimal allowed length of the Y-axis values spread
   */
  valuesMinSpread: _propTypes2.default.number,
  /**
   * If true, shows the stacked area graph, otherwise show a simple line graph
   */
  showStacked: _propTypes2.default.bool,
  /**
   * If true, show only data for one series in the tooltip, otherwise show all
   */
  simpleTooltip: _propTypes2.default.bool,
  /**
   * If true, shows a loading overlay on top of the graph
   */
  loading: _propTypes2.default.bool,
  /**
   * If set, shows the error message over the graph
   */
  error: _propTypes2.default.string,
  /**
   * Making graph legend section collapsable
   */
  legendCollapsable: _propTypes2.default.bool,
  /**
   * Display legend section initially
   */
  legendShown: _propTypes2.default.bool,
  /**
   * Initially preselected legend items
   */
  selectedLegendKeys: _propTypes2.default.array,
  /**
   * Called when legend selection changes
   */
  onChangeLegendSelection: _propTypes2.default.func,
  /**
   * Optional list of deployment annotations shown over the graph
   */
  deployments: _propTypes2.default.array
};

PrometheusGraph.defaultProps = {
  getSeriesName: getDefaultSeriesName,
  colorTheme: 'mixed',
  metricUnits: 'numeric',
  valuesMinSpread: 0.012,
  showStacked: false,
  simpleTooltip: false,
  legendCollapsable: false,
  legendShown: true,
  loading: false,
  onChangeLegendSelection: _noop3.default,
  selectedLegendKeys: [],
  deployments: []
};

exports.default = PrometheusGraph;