'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TabName = _styledComponents2.default.span.withConfig({
  displayName: '_TabButton__TabName'
})(['']);

var getBgColor = function getBgColor(selected, secondary, theme) {
  if (secondary) {
    return theme.colors.purple25;
  }

  return selected ? theme.colors.white : theme.colors.gallery;
};

var Styled = function Styled(component) {
  return (0, _styledComponents2.default)(component).withConfig({
    displayName: '_TabButton'
  })(['cursor:pointer;margin-bottom:-1px;margin-right:5px;padding:10px 20px;font-size:', ';outline:0;', ';', ';', '{color:', ';opacity:', ';}'], function (props) {
    return props.theme.fontSizes.large;
  }, function (_ref) {
    var selected = _ref.selected,
        secondary = _ref.secondary,
        theme = _ref.theme;
    return '\n    background-color: ' + getBgColor(selected, secondary, theme) + ';\n    border-top-left-radius: ' + theme.borderRadius.soft + ';\n    border-top-right-radius: ' + theme.borderRadius.soft + ';\n    border: 1px solid ' + theme.colors.purple100 + ';\n  ';
  }, function (props) {
    return props.selected && 'border-bottom: 1px solid transparent;';
  }, TabName, function (props) {
    return props.theme.colors.purple900;
  }, function (props) {
    return props.selected ? 1 : 0.65;
  });
};

var TabButton = function (_React$Component) {
  _inherits(TabButton, _React$Component);

  function TabButton() {
    var _ref2;

    var _temp, _this, _ret;

    _classCallCheck(this, TabButton);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref2 = TabButton.__proto__ || Object.getPrototypeOf(TabButton)).call.apply(_ref2, [this].concat(args))), _this), _this.handeClick = function (ev) {
      _this.props.onClick(ev, _this.props.name);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(TabButton, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          children = _props.children;

      return _react2.default.createElement(
        'button',
        { onClick: this.handeClick, className: className },
        _react2.default.createElement(
          TabName,
          null,
          children
        )
      );
    }
  }]);

  return TabButton;
}(_react2.default.Component);

exports.default = Styled(TabButton);