'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TimelineRangeOverlay = _styledComponents2.default.div.attrs({
  style: function style(_ref) {
    var x = _ref.x,
        width = _ref.width;
    return {
      transform: 'translateX(' + x + 'px)',
      width: width
    };
  }
}).withConfig({
  displayName: '_TimelineRange__TimelineRangeOverlay'
})(['background-color:', ';position:absolute;opacity:0.15;height:100%;'], function (props) {
  return props.color;
});

var TimelineRange = function TimelineRange(_ref2) {
  var color = _ref2.color,
      timeScale = _ref2.timeScale,
      startAt = _ref2.startAt,
      endAt = _ref2.endAt,
      width = _ref2.width;

  var endShift = endAt ? Math.min(timeScale((0, _moment2.default)(endAt)), width) : width;
  var startShift = startAt ? Math.max(timeScale((0, _moment2.default)(startAt)), -width) : -width;

  // If the range interval is very short or we're zoomed out a lot, render the
  // interval as at least 4 pixels wide. Then re-adjust the left end of the
  // interval to account for the calibrated min-width.
  var length = Math.max(4, endShift - startShift);
  startShift = endShift - length;

  return _react2.default.createElement(TimelineRangeOverlay, { color: color, x: startShift, width: length });
};

TimelineRange.propTypes = {
  color: _propTypes2.default.string.isRequired,
  timeScale: _propTypes2.default.func.isRequired,
  startAt: _propTypes2.default.string,
  endAt: _propTypes2.default.string,
  width: _propTypes2.default.number.isRequired
};

exports.default = TimelineRange;