'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.atoms = undefined;

var _polished = require('polished');

var _colors = require('./colors');

// component-specific
var atoms = exports.atoms = {
  Alert: {
    default: {
      color: _colors.colors.black,
      background: _colors.colors.gallery,
      borderColor: (0, _polished.darken)(0.15, _colors.colors.gallery)
    },
    info: {
      color: _colors.colors.white,
      background: _colors.colors.blue600,
      borderColor: (0, _polished.darken)(0.15, _colors.colors.blue600)
    },
    success: {
      color: _colors.colors.white,
      background: _colors.colors.status.success,
      borderColor: (0, _polished.darken)(0.15, _colors.colors.status.success)
    },
    warning: {
      color: _colors.colors.white,
      background: _colors.colors.status.warning,
      borderColor: (0, _polished.darken)(0.15, _colors.colors.status.warning)
    },
    error: {
      color: _colors.colors.white,
      background: _colors.colors.status.error,
      borderColor: (0, _polished.darken)(0.15, _colors.colors.status.error)
    }
  },
  Button: {
    default: {
      color: _colors.colors.black,
      background: _colors.colors.white,
      hoverColor: _colors.colors.purple800,
      hoverBackground: (0, _polished.darken)(0.05, _colors.colors.white)
    },
    primary: {
      color: _colors.colors.white,
      background: _colors.colors.blue700,
      hoverColor: _colors.colors.white,
      hoverBackground: (0, _polished.darken)(0.05, _colors.colors.blue700)
    },
    danger: {
      color: _colors.colors.white,
      background: _colors.colors.status.error,
      hoverColor: _colors.colors.white,
      hoverBackground: (0, _polished.darken)(0.05, _colors.colors.status.error)
    },
    disabled: {
      color: _colors.colors.doveGray,
      background: _colors.colors.gallery,
      hoverColor: _colors.colors.doveGray,
      hoverBackground: _colors.colors.gallery
    }
  }
};