'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.themeVarsAsScss = themeVarsAsScss;

var _colors = require('./colors');

var _fonts = require('./fonts');

var _borders = require('./borders');

var _layers = require('./layers');

var _misc = require('./misc');

var _boxShadows = require('./box-shadows');

var _atoms = require('./atoms');

function themeVarsAsScss() {
  var themeVariables = [].concat((0, _colors.themeColorsAsScss)()).concat((0, _layers.themeLayersAsScss)()).concat((0, _fonts.themeFontsAsScss)()).concat((0, _borders.themeBorderRadiiAsScss)()).concat((0, _misc.themeMiscVarsAsScss)());
  return themeVariables.join('; ') + ';';
}

var theme = {
  // Component-specific
  atoms: _atoms.atoms,

  // Box shadows
  boxShadow: _boxShadows.boxShadow,

  // Borders
  borderRadius: _borders.borderRadius,

  // Colors
  colors: _colors.colors,

  // Fonts
  fontFamilies: _fonts.fontFamilies,
  fontSizes: _fonts.fontSizes,

  // z-index layers
  layers: _layers.layers,

  // Misc
  overlayIconSize: _misc.overlayIconSize,
  textColor: _misc.textColor
};

exports.default = theme;