'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

exports.nowInSecondsPrecision = nowInSecondsPrecision;
exports.scaleDuration = scaleDuration;
exports.clampDuration = clampDuration;

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function nowInSecondsPrecision() {
  return (0, _moment2.default)().startOf('second');
}

// This is unfortunately not there in moment.js
function scaleDuration(duration, scale) {
  return _moment2.default.duration(duration.asMilliseconds() * scale);
}

function clampDuration(duration, _ref) {
  var _ref2 = _slicedToArray(_ref, 2),
      minDuration = _ref2[0],
      maxDuration = _ref2[1];

  var durationMs = duration.asMilliseconds();
  if (minDuration && minDuration.asMilliseconds() > durationMs) {
    durationMs = minDuration.asMilliseconds();
  }
  if (maxDuration && maxDuration.asMilliseconds() < durationMs) {
    durationMs = maxDuration.asMilliseconds();
  }
  return _moment2.default.duration(durationMs);
}